10 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
20 ' Nonumber.bas built by Keith Williams upon Renumber.bas from Geoff Graham.
30 '     Geoff Graham 2010 and Keith Williams 2012.
40 '
50 '   Version NNumb4 -- 3/1/2012
60 '
70 ' Renumber.bas renumbered a basic program including references
80 ' to line numbers in statements.  It is written for MMBasic but it
90 ' can easily be converted to other BASICs.  To do this change:
100 '  - the error statement to: print msg: end
110 '  - edit the data statement to add any other commands
120 '  - delete comments if your BASIC does not support the ' char
130 '
140 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
150 '
160 Cls
170 maxlines = 1000
180 Dim lines(maxlines)
190 '
200 Maxlabels = 100
210 Dim Labels(maxlabels,3)
220 '
230 Print : Print " This program will replace line numbers with labels."
240 Print
250 Print " A GOTO will be inserted before line numbers after THEN or ELSE."
260 Print " Minimal error checking is done,programs require prior debugging."
270 Print : Print
280 Input "Program to de-number: ", iname$
290 Open iname$ For INPUT As #1
300 Input "    Output file name: ", oname$
310 Open "NNXXX.bas" For output As #2
320 '
330 '
340 nbrlines = 0
350 Do While Not Eof(#1)
360   Line Input #1, inp$
370   lines(nbrlines) = Val(inp$)
380   nbrlines  = nbrlines  + 1
390   If nbrlines  > maxlines Then Error "Program has too many lines"
400 Loop
410 Close #1
420 Print : Print " Processing Pass 1 " : Print
430 Lcount = 0
440 Open iname$ For INPUT As #1
450 For lineindex = 0 To nbrlines - 1
460   Line Input #1, inp$
470   GoSub 740  ' process the line
480   Print #2, Left$(inp$, Len(inp$) - 3)
490   Print ".";
500 Next lineindex
510 '
520 Close #1, #2
530 Print
540 Print : Print " Finished Pass 1, processed";nbrlines;" lines" : Print
550 GoTo 2760 ' Now preproc for pas 2
560 '
570 '
580 '
590 ''''''''''''''''''''''''''''''''''''''''''''
600 'subroutines
610 ''''''''''''''''''''''''''''''''''''''''''''
620 'Keywords that use line numbers
630 'the list must be in pairs with each keyword in uppercase
640 'followed by lowercase. The last entry must be an empty
650 'string (ie, "").
660 Data "GOTO","GOSUB","THEN","ELSE","SETPIN","SETTICK","ON",""
670 '
680 '
690 ''''''''''''''''''''''''''''''''''''''''''''
700 'subroutine
710 'process a line (in inp$) and replace all
720 'line numbers.  returns with inp$ updated
730 ''''''''''''''''''''''''''''''''''''''''''''
740 original$ = inp$
750 ptr = 1
760 'first remove the line number
770 'skip spaces
780 Do
790   GoSub 2630
800   If endstmt Then Error "No line number in: " + original$
810 Loop While ch$ = " "
820 '
830 'skip numeric digits
840 Do While ch$ >= "0" And ch$ <= "9"
850   GoSub 2630
860 If endstmt Then Error "No statement in: " + original$
870 Loop
880 '
890 'print the new line number
900 inp$ = "   " + Mid$(inp$, ptr) + "   "
910 '
920 'for each keyword, check if it is there and then change the line number
930 'then repeat for the same keyword until there are no more on the line
940 'then step to the next keyword and repeat
950 Restore    : n = 0
960 uinp$ = UCase$(inp$)
970 Do
980   Read kw$
990   If kw$ = "" Then Return               'null means end of list
1000   n = n + 1    : ptr = 1 : GFlag = 0
1010   Do
1020     ptr = Instr(ptr, uinp$, kw$)  'find the keyword
1030     If ptr <> 0 Then
1040       ptr = ptr + Len(kw$)             'step over it and process
1050       On n GoSub 1400, 1400, 1370, 1370, 2300, 2470, 1240
1060     EndIf
1070   Loop While ptr <> 0
1080 Loop
1090 '
1100 '
1110 '''''''''''''''''''''''''''''''''''''''''''''''''
1120 'subroutine
1130 'process an ON statement
1140 '''''''''''''''''''''''''''''''''''''''''''''''''
1150 '
1160 'later scans for gosub/goto will find the first
1170 'line number following the gosub/goto so we only
1180 'need to look for a comma and process the line
1190 'number after it.  Fortunatly the subroutine for
1200 'processing settick does exactly that so we just
1210 'repeatedly call it until we hit the end of the
1220 'statement
1230 '
1240 Do
1250   GoSub 2470
1260 Loop While Not endstmt
1270 Return
1280 '
1290 ''''''''''''''''''''''''''''''''''''''''''''''''''
1300 'subroutine
1310 'process a (possible) line number following a GOTO,
1320 'GOSUB, THEN or ELSE
1330 'also called by other routines that have navigated
1340 'to a possible line nbr
1350 ''''''''''''''''''''''''''''''''''''''''''''''''''
1360 ' Set GFlag = need Goto inserted
1370 GFlag = 1 ' Flag set
1380 '
1390 'first skip any spaces
1400 Do
1410   GoSub 2630
1420   If endstmt Then Return
1430 Loop  While ch$ = " "
1440 '
1450 ' then get the number (if there)
1460 nbrstr$ = "" : Qcolon = 0
1470 Do While ch$ >= "0" And ch$ <= "9"
1480   nbrstr$ = nbrstr$ + ch$
1490   GoSub 2630
1500 ' Fix to Renumber ****
1510   If endstmt Then
1520     If Mid$(inp$, ptr, 1) = ":" Then
1530       ptr = ptr + 1 : Qcolon = 1
1540     EndIf
1550     Exit
1560   EndIf
1570 Loop
1580 If Val(nbrstr$) = 0 Then Return  ' no line number
1590 '
1600 'got a line number, find it in the table
1610 nbr = Val(nbrstr$)
1620 For i = 0 To nbrlines - 1
1630   If lines(i) = nbr Then 1700
1640 Next i
1650 Print : Print "Cannot find line number " + nbrstr$ + " in: " + original$ : Return
1660 '
1670 'splice the new temp label (Labc) into the line
1680 '  Modified label positioning
1690 '
1700  oldnposn = (ptr - Len(nbrstr$)) - 2 : oldptr = ptr
1710  cx = 4 - Len(nbrstr$) 'difference in label length
1720 '
1730 If Gflag = 0 Then ' check not a THEN or ELSE ?
1740 '
1750   Lab$ = "Labc"
1760   ptr = oldnposn + 4
1770   nposn = oldnposn
1780 '
1790 Else
1800 '
1810   Lab$ = "GoTo Labc"
1820   ptr = oldnposn + 9
1830   nposn = oldnposn + 5
1840   cx = cx + 5
1850 '
1860 EndIf
1870 '
1880 If Qcolon = 1 Then ' need extra space post colon ?
1890   Lab$ = Lab$ + " "
1900   ptr = ptr + 1
1910   cx = cx + 1
1920 EndIf
1930 '
1940 inp$ = Left$(inp$,oldnposn) + Lab$ + Mid$(inp$,oldptr - 1 )
1950 '
1960 uinp$ = UCase$(inp$) ' back to upper case for testing
1970 '
1980 '
1990 ' Build Array # 1
2000 '
2010 labels(lcount,1) = Lineindex+1 ' Line Number "
2020 labels(lcount,2) = nposn       ' Offset to label
2030 labels(lcount,3) = i           ' label address
2040 '
2050 ' Fix array for changing offsets *** 3/1/2012
2060 '
2070 If cx <> 0 Then              ' was there an offset change?
2080 '
2090   For p = 1 To lcount - 1    ' current size of array without last
2100     q = labels(p,1)          ' get the line number
2110     If q = lineindex+1 Then  ' same as current line # ?
2120       r = labels(p,2)        ' get the saved offset
2130       If r > nposn Then      ' past present offset?
2140         labels(p,2) = r + cx ' adjust offset
2150       EndIf
2160     EndIf
2170   Next p
2180 '
2190 EndIf
2200 '
2210 Lcount = Lcount + 1            ' Increment Array 1 index
2220 Return
2230 '
2240 ''''''''''''''''''''''''''''''''''''''''''''''''''''
2250 'subroutine
2260 'process a setpin statement
2270 ''''''''''''''''''''''''''''''''''''''''''''''''''''
2280 '
2290 'search for the first comma
2300 Do While ch$ <> ","
2310   GoSub 2630
2320   If endstmt Then Return
2330 Loop
2340 '
2350 'fall through to the settick processing which looks for a comma
2360 'and then processes the following text as a line number
2370 '
2380 '
2390 '''''''''''''''''''''''''''''''''''''''''''''''''''''
2400 'subroutine
2410 'process the settick statement
2420 'also used by the processing for setpin and on statements
2430 ''''''''''''''''''''''''''''''''''''''''''''''''''''
2440 '
2450 'search for the comma
2460 ch$ = "x" ' Fix for Renumber to do SetPin subroutines
2470 Do While ch$ <> ","
2480   GoSub 2630
2490   If endstmt Then Return
2500 Loop
2510 GoTo 1400 ' get and process the line number
2520 '
2530 '
2540 ''''''''''''''''''''''''''''''''''''''''''''''''''''''
2550 'subroutine
2560 'step through the text and return the next character
2570 'the text is inp$ and the start position is ptr
2580 'returns the character found in ch$ and ptr is incremented
2590 'returns with endstmt = true if reached the end of the
2600 'line or a new statement
2610 ''''''''''''''''''''''''''''''''''''''''''''''''''''''
2620 '
2630 endstmt = -1 : ch$ = Chr$(1)
2640 If ptr >= Len(inp$) Then Return  'end of the line
2650 If Mid$(inp$, ptr,1) = ":" Then Return ' new statement
2660 ch$ = Mid$(inp$, ptr, 1)
2670 endstmt = 0
2680 ptr = ptr + 1
2690 Return
2700 '
2710 ' Additions to Geoff's Renumber to make Nonumber
2720 ' **********************************************
2730 '
2740 ' Build Array #2
2750 '
2760 lines(0) = 0
2770 lines(1) = 0
2780 For i = 0 To Lcount - 1
2790   lines(i) = labels(i,3)
2800 Next i
2810 '
2820 lines(Lcount) = 0 ' Mark end of list
2830 '
2840 '
2850 ' Sort Destinations into assending  order
2860 '
2870 s=1
2880 While s = 1
2890   s = 0
2900   For x = 0 To lcount - 2
2910     If lines(x) > lines(x + 1) Then
2920       t = lines(x)
2930       lines(x) = lines(x + 1)
2940       lines(x + 1 ) = t
2950       s = 1
2960     EndIf
2970   Next
2980 Wend
2990 '
3000 '
3010 ' Compact Destinations -remove duplications
3020 '
3030 x = 1
3040 Do While lines(x) <> 0 And x < lcount
3050   Do While lines(x) = lines(x + 1 )
3060     For p = x To Lcount
3070       lines(p) = lines(p + 1)
3080     Next p
3090   Loop
3100   x = x + 1
3110 Loop
3120 '
3130 destn = x
3140 '
3150 ' Place new label numbers into Array #1
3160 '
3170 For x = 0 To destn - 1
3180  For i = 0 To lcount - 1
3190   If lines(x) = labels(i,3) Then labels(i,3) = x
3200  Next i
3210 Next x
3220 '
3230 '
3240 ' Do Pass 2 process
3250 ' *****************
3260 '
3270 Print : Print " Starting Pass 2 " : Print
3280 '
3290 Open "NNXXX.bas" For input As #1
3300 Open oname$ For output As #2
3310 '
3320 i = 0 : j = 0 'start of tables
3330 '
3340 For lineindex = 1 To nbrlines
3350  Line Input #1, inp$
3360  GoSub 3560 ' add the labels
3370  Print #2, inp$
3380  Print "*";
3390 Next Lineindex
3400 '
3410 Close #1,#2
3420 '
3430 Kill "NNXXX.bas"
3440 '
3450 Print : Print : Print " Finished Pass 2" : Print
3460 '
3470 Print " Placed " + Format$(j,"% 3.0f") + " Incidence Labels into Program '" + oname$ + "'"
3480 Print " Placed " + Format$(i,"% 3.0f") + " Destination Labels"
3490 End
3500 '
3510 ' Subroutine for placing labels into line
3520 ' ****************************************
3530 '
3540 ' Process all Incidence labels for this line
3550 '
3560 If Lcount <> 0 Then
3570 If j < Lcount Then ' Lcount = # of Incidence
3580   Do While Lineindex = Labels(j,1) 'test for line number
3590     Labl$ = "L" + Format$((labels(j,3) + 1),"%03.0f")
3600     offst = labels(j,2)
3610     inp$ = Left$(inp$,offst) + Labl$ + Mid$(inp$,offst + 5)
3620     j = j + 1
3630   Loop
3640 EndIf
3650 '
3660 ' Now any Destination Label for this line?
3670 '
3680     If lineindex = lines(i) + 1 And i < destn Then
3690       Labl$ = "L" + Format$(i + 1,"%03.0f") + ":"
3700       inp$ = labl$ + Mid$(inp$,3)
3710       i = i + 1
3720     EndIf
3730 EndIf
3740 '
3750 Return